// EListBox.cpp : implementation file
//

#include "stdafx.h"
#include "ELB.h"
#include "EListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEListBox

CEListBox::CEListBox()
{
	m_pEdit = NULL;
}

CEListBox::~CEListBox()
{
	if (m_pEdit)
	{
		delete m_pEdit;
		m_pEdit = NULL;
	}
}


BEGIN_MESSAGE_MAP(CEListBox, CListBox)
	//{{AFX_MSG_MAP(CEListBox)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEListBox message handlers

void CEListBox::InitEdit(CPoint point)
{
	// Gets current selection
	int Index = GetCurSel();
	if (Index != LB_ERR)	// If there is a valid selection
	{
		// Gets item rectangle
		CRect Rect;
		GetItemRect(Index, Rect);
		// Creats an edit box around the item
		m_pEdit = new CEdit;
		m_pEdit->Create(WS_CHILD | WS_VISIBLE | WS_BORDER, Rect, this, WM_USER + Index);
		// Sets edit box font as display font of list box
		m_pEdit->SetFont(GetFont());
		// Copies item string to edit box
		CString Text;
		GetText(Index, Text);
		m_pEdit->SetWindowText(Text);
	}
}

void CEListBox::EndEdit()
{
	if (m_pEdit)		// If editing is on
	{
		// Copies edit box text to item
		CString Text;
		m_pEdit->GetWindowText(Text);
		int Index = m_pEdit->GetDlgCtrlID() - WM_USER;
		// Changing of string is effectively deleting current atring
		// And adding the modified string
		DeleteString(Index);
		InsertString(Index, Text);
		// Deletes the edit box and points pointer to NULL
		delete m_pEdit;
		m_pEdit = NULL;
	}
}

void CEListBox::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	InitEdit(point);
	CListBox::OnLButtonDblClk(nFlags, point);
}
